package ${basePackage}.action.ajax.system;

import org.springframework.beans.factory.annotation.Autowired;
import ${basePackage}.frame.auth.LocalData;
import ${basePackage}.frame.utils.MapperUtil;
import ${basePackage}.module.system.mgr.DictItemManager;
import ${basePackage}.module.system.req.*;
import ${basePackage}.module.system.rsp.*;

public class DictItemAjax {

    @Autowired
    private DictItemManager dictManager;

    public DictItemCreateResponse create(String jsonParam) {
        DictItemCreateRequest request = MapperUtil.toJava(jsonParam, DictItemCreateRequest.class);
        return dictManager.create(request, LocalData.getToken());
    }

    public DictItemDeleteResponse delete(String jsonParam) {
        DictItemDeleteRequest request = MapperUtil.toJava(jsonParam, DictItemDeleteRequest.class);
        return dictManager.delete(request, LocalData.getToken());
    }

    public DictItemUpdateResponse update(String jsonParam) {
        DictItemUpdateRequest request = MapperUtil.toJava(jsonParam, DictItemUpdateRequest.class);
        return dictManager.update(request, LocalData.getToken());
    }

    public DictItemFindResponse find(String jsonParam) {
        DictItemFindRequest request = MapperUtil.toJava(jsonParam, DictItemFindRequest.class);
        return dictManager.find(request, LocalData.getToken());
    }

    public DictItemGetResponse get(String jsonParam) {
        DictItemGetRequest request = MapperUtil.toJava(jsonParam, DictItemGetRequest.class);
        return dictManager.get(request, LocalData.getToken());
    }
}
